$(function(){

    window.htmlspecialchars = function (str) {
        if (typeof(str) == "string") {
            str =  str.replace(/&/g, '&amp;').replace(/"/g, '&quot;').replace(/'/g, '&#039;').replace(/</g, '&lt;').replace(/>/g, '&gt;');
        }
        return str;
     }

	window.confirmLeave = function() { 
		var result = app.saved;
        if (!result)  result  = confirm(tr("functions.generic.ducument_not_saved"));
        return result;
    }

    //безоопасный разбор JSON
	window.parseJSON = function(data) { 
	    var d =false;
	    try { d = JSON.parse(data); } catch (e) {};   
	    return d;
	}


	window.diagramFromJson = function(r) { 
        appView.graph.fromJSON(r);

        _.each(appView.graph.getElements(), function(m) {
            if ("m_attr" in m.attributes) { 
                m.attributes.m_attr.shape = m;
                m.attributes.m=new app.FuncModel(m.attributes.m_attr); 

                var file = _.find(functions, function(a){
                    return a.file  ==   m.attributes.m.get("file");
                });
                if (file) { 
                    var func = _.find(file.funcs, function(a){
                        return a.name  ==   m.attributes.m.get("name");
                    });
                    if (func) {
                        for (var i in m.attributes.m.attributes.input) 
                            m.attributes.m.attributes.input[i].t = func.input[i].t;
                        for (var i in m.attributes.m.attributes.output) {
                            m.attributes.m.attributes.output[i].t = func.output[i].t;
                            m.attributes.m.attributes.output[i].l = func.output[i].l;
                        }
                    }
                }

                //console.log( m.attributes.m, functions);
                m.attributes.m.updateShape();
                delete m.attributes.m_attr;
                if (m.init) m.init();
            }
        });

        _.each(appView.graph.getLinks(), function(l) { 
            changeTarget(l);
        });
	}

    //символ по типам объектов  
	window.getIcon = function(t) { 
		var text = ""; 

        if (t=="object") text = String.fromCharCode(61874);
        else if (t=="storage") text = String.fromCharCode(61888);
        else if (t=="timer") text = String.fromCharCode(61463);
        else if (t=="tag") text = String.fromCharCode(61484);
        else if (t=="value") text = String.fromCharCode(61508);
        else if (t=="unique_string") text = String.fromCharCode(61765);

		return text;
	}

	window.writeAddress = function(a, v) { 
		if (mapping.o[a]){
			_.each(mapping.o[a], function(s) {
				v = v.toString();
				if (s.model) s.model.changeValue(s.options, v);
			})
		}
	}

	window.writeStorage = function(a, v) { 
		_.each(mapping.s[a], function(s) {
			v = v.toString();
			if (s.model) s.model.changeValue(s.options, v);
		})
	}

    //совместимый ли тип данных 
	window.isEnabledDataTypeForPort = function(name, p, isEvent) { 
        if (name=="tag" && isEvent) name = "object";

        if ("t" in p && _.isArray(p.t)) {
            return _.indexOf(p.t, name)>=0; 
        }
        return true;
    }

    //тип данных для входящих параметров по умолчанию
    window.defaultInputTypeValue = function(i) {
        var defTypeValue = "value";
        if ("t" in i && _.isArray(i.t) && i.t.length>0) defTypeValue = i.t[0];
        return defTypeValue;
    }

    //создать ссылку между функциями 
    window.createLink2Func = function(trg, inNum, src, isEvent, value) { 
    	var inputs = trg.get("input");
        var t = src.get("type");

    	if (_.isArray(inputs) && inputs.length>inNum) { 
            if (t=="qad.Question") { 
                if (!isEvent) {
                    inputs[inNum].value = {
                        type : "function",
                        value : false, 
                    } 
                }else{
                    inputs[inNum].value = {
                        type : "object",
                        value : value, 
                        link : true,
                        isEvent : true 
                    } 
                }
            }else if (t=="qad.Addressnotevent") {
                inputs[inNum].value = {
                    type : "object",
                    value : src.get("value"), 
                    link : true
                } 
            }else if (t=="qad.Storage") { 
                inputs[inNum].value = {
                    type : "storage",
                    value : src.get("value"), 
                    link : true
                } 
            }else if (t=="qad.Value") { 
                inputs[inNum].value = {
                    type : "value",
                    value : src.get("value"), 
                    link : true
                } 
            }else if (t=="qad.Address") { 
                inputs[inNum].value = {
                    type : "object",
                    value : src.get("value"), 
                    link : true,
                    isEvent : true 
                } 
            }else if (t=="qad.Tag") {     
                inputs[inNum].value = {
                    type : "tag",
                    value : src.get("value"), 
                    link : true,
                    isEvent : true 
                } 
            }

    		trg.set("input", inputs);

			if (rightView.model==trg) { 
				rightView.clearAll();
				rightView.initModel(trg.get("shape"));
			}

    		trg.updateShape();
    		return true;
    	};
    	return false;
    }

    //удаление ссылки во входящий порт функции 
    window.removeLinkFunc2Func = function(trg, inNum) { 
    	var inputs = trg.get("input");

    	if (_.isArray(inputs) && inputs.length>inNum) { 
    		inputs[inNum].value = {
    			type : defaultInputTypeValue(inputs[inNum]),
    			value : false, 
    		}
    		trg.set("input", inputs);

			if (rightView.model==trg) { 
				rightView.clearAll();
				rightView.initModel(trg.get("shape"));
			}

    		trg.updateShape();
    		return true;
    	};
    	return false;
    }

    

    //проверка ссылок 
    window.checkLinks = function(c) {
    	_.each(appView.graph.getLinks(), function(l){
    		var p = getTargetSource(l);
    		//исходящие 
    		if (p.src && p.src.cell && p.src.cell==c) { 
    			if (!p.src.port) l.remove();
				if (!p.trg || !p.trg.port || !p.trg.cell) l.remove();

    			var outPort = p.src.port[0], inPort = p.trg.port[0];

    			if (inPort.getAttribute("type")=="input" /*event*/ && outPort.getAttribute("enableEvent")!="1" /*не event*/) {
    				l.remove();
    			}

    		}
    	})
    }

    //свободен ли входящий event порт блока 
    window.isEventFree = function(c, link) { 
        var isBusy = _.find(appView.graph.getLinks(), function(l){
            if (link && l==link) return false;
            var p = getTargetSource(l);
            if (p.trg && p.trg.cell && p.trg.cell==c && p.trg.port) 
                return p.trg.port[0].getAttribute("type")=="input";

            return false;
        })
        return _.isUndefined(isBusy);
    }


    //указан какой именно из портов event и это не timer 
    window.isEventDefined = function(c) { 
        var m = c.get("m");
        var ev = m.get("event");
        if (ev!="timer") ev = parseInt(ev);
        if (_.isNumber(ev) && !_.isNaN(ev)) {
            var inputs = m.get("input");
            return _.isArray(inputs) && inputs.length>0 && ev>=0 && ev<inputs.length;
        }
        return false;
    }

    window.positionCellFreePlace = function(cell, x, y, step) { 
        if (!step) step = 10; 
        var found = true;
        while (found) {
            x = x + step;
            y = y + step;
            found = false;
            _.each(appView.graph.getElements(), function(e) {
                var b = e.getBBox();
                if (Math.abs(x - b.x) < 10 && Math.abs(y - b.y < 10)) found = true;
            })
        }
        cell.position(x, y);
    }

    window.addZero = function(v) { 
        return v<10 ? "0" + v : v;
    }

    /*для ссылки старт и окончание*/
    window.getTargetSource = function(l) {
        var res = {},
            graph = appView.graph,
            paper = appView.paper;
        if (!l.get) return res;
        var id;
        try { id = l.get('target').id || l.previous('target').id; } catch (exception_var) {}
        if (id) {
            res.trg = {};
            res.trg.cell = graph.getCell(id);
            var s = l.get('target').selector || l.previous('target').selector;
            if (res.trg.cell && res.trg.cell.findView(paper))
                res.trg.port = $(s, res.trg.cell.findView(paper).$el);
        }

        id = l.get('source').id || l.previous('source').id;
        if (id) {
            res.src = {};
            res.src.cell = graph.getCell(id);
            var s = l.get('source').selector || l.previous('source').selector;
            if (res.src.cell && res.src.cell.findView(paper))
                res.src.port = $(s, res.src.cell.findView(paper).$el);
        }
        return res;
    }

    /*все ссылки триггеры для блока - функции*/
    window.getTriggersForFunction = function (cell) {
        //return array();
        //return _.filter(appView.graph.getLinks(), function(l){

        return _.filter(appView.graph.getConnectedLinks(cell, {inbound:true}), function(l){            
            var p = getTargetSource(l);
            //console.log(p.trg.port);
            if (p.trg /*&& p.trg.cell && p.trg.cell==cell*/ && p.trg.port  && p.trg.port.length>0) { 
                var port = p.trg.port[0];
                return port.getAttribute("type") == "input";
            }
            return false;
        })
    }


    //все исходящие ссылки из функции в элементы
    window.getLinksFromFunctionsToElements = function(cell) { 
        return _.filter(appView.graph.getConnectedLinks(cell, {outbound:true}), function(l){
            var p = getTargetSource(l);

            if (p.trg && p.trg.cell && p.trg.port  && p.trg.port.length>0 &&
                (p.trg.cell.get("type")=="qad.Address" || p.trg.cell.get("type")=="qad.Addressnotevent" || p.trg.cell.get("type")=="qad.Storage")) {
                return true;
            }
            return false;
        })
    }


    window.getLinksFromFunctionsToFunctionNotEvent = function(cell) { 
        return _.filter(appView.graph.getConnectedLinks(cell, {outbound:true}), function(l){
            var p = getTargetSource(l);

            if (p.trg && p.trg.cell && p.trg.port  && p.trg.port.length>0 &&
                (p.trg.cell.get("type")=="qad.Question")) {
                console.log(l.attr('.connection'));
                return true;
            }
            return false;
        })
    }

    /*если изменилось значение у связанного элемента, то нужно поменять значение у параметра функции*/
    window.updateLinkedQuestion = function(cell) { 
        var links = appView.graph.getConnectedLinks(cell, {outbound:true});
        if (links && links.length>0) { 
            _.each(links, function(l){
                var ts = getTargetSource(l);
                if (ts.trg && ts.trg.cell) {
                    var inNum = ts.trg.port[0].getAttribute("option-id");
                    var trCell = ts.trg.cell;
                    var m = trCell.get("m"), inputs = m.get("input");
                    if (_.isArray(inputs) && inputs.length>inNum) { 
                        inputs[inNum].value.value = cell.get("value");
                        m.set("input", inputs);
                        if (rightView.model==m) { 
                            rightView.clearAll();
                            rightView.initModel(m.get("shape"));
                        }
                        m.updateShape();
                    }
                }
            })
        }
    }

    window.generateCode = function(preview) { 
        appView.selection.error = true;
        var error;

        //валидация 
        var m = _.find(appView.graph.getElements(), function(m) {
            /*if (m.get("type")=="qad.Question"){ 
                if (m.get("free")) {
                    error = "Не указана входящая ссылка";
                } 
            }*/

            if (!error && (m.get("type")=="qad.Address" || m.get("type")=="qad.Tag" || m.get("type")=="qad.Timer"  || m.get("type")=="qad.Addressnotevent" 
                 || m.get("type")=="qad.Storage"  || m.get("type")=="qad.Value")) { 
                var l = _.find(appView.graph.getLinks(), function(l){
                    var p = getTargetSource(l);
                    return (p.src && p.src.cell && p.src.cell==m) || (p.trg && p.trg.cell && p.trg.cell==m);
                })
                if (!l) error = tr("functions.generic.one_link_missing");
            }

            if (!error &&  (m.get("type")=="qad.Address" || m.get("type")=="qad.Tag"  || m.get("type")=="qad.Addressnotevent"  || m.get("type")=="qad.Storage"   || m.get("type")=="qad.Value")) { 
                var v = m.get("value");
                if (!_.isString(v) || v.length==0)  error = tr("functions.generic.missing_paramter");
            }                        

            if (!error && m.get("type")=="qad.Timer") { 
                var  v = parseInt(m.get("value"));
                if (_.isNaN(v)) error =  tr("functions.generic.missing_timer");
            }

            return error;
        })

        if (m) {
            console.log(error);
            new app.ModalError({error:error, reveal : {closeOnClick:true, closeOnEsc:true,}});
            appView.selection.reset([m]);
        }else { 
            var res = [];
            //проходим все блоки - функции 
            var cell = _.find(appView.graph.getElements(), function(cell) {
                if (cell.get("type")=="qad.Question") { 
                    var m = cell.get("m");
                    if (!m) return true;

                    var f = {inputs:[], outputs:[], triggers:[], name : m.get("name"), file:m.get("file"), id:cell.get("id")};

                    var e = m.get("event");

                    //входящие параметры
                    _.each(m.get("input"), function(i, _nPort){

                        var v = false, find = false;
                        if (_.isObject(i.value) && i.value.value!==false) { 
                            v = i.value;
                            if (v.type=="object" && i.fa) find = true; 
                            else if (v.type=="tag" && (i.fa || i.ft)) find = true;


                            if (e!=="timer" && v.isEvent) {
                                var trigg = { 
                                    t : "event", 
                                    n : _nPort + 1, 
                                    ot : v.type=="object"  ? "address" : "tag",
                                    v  : v.value
                                }
                                f.triggers.push(trigg);
                            }
                        }
                        var inp = {n:i.n, v:v, e:i.value.isEvent};
                        if (find) inp.find = true;
                        f.inputs.push(inp);
                    }) 

                    //исходящие параметры //сначала добавляем обычные
                    _.each(m.get("output"), function(i){
                         
                        var v = false;
                        if (_.isArray(i.values)) { 
                            v = i.values;
                        }
                        var out = {n:i.n, v:v, bus: _.isUndefined(i.bus) ? true : i.bus};
                        var delta = parseFloat(i.delta);
                        if (!_.isNaN(delta)) out.delta = delta;
                        f.outputs.push(out);
                        //теперь посмотрим ссылки 
                    }) 

                    //исходщие параметры по ссылке 
                    _.each(getLinksFromFunctionsToElements(cell), function(l) {
                        var p = getTargetSource(l);
                        var tc = p.trg.cell, v = tc.get("value");
                        if ( v!==false ) { 
                            var t = false;
                            if (tc.get("type")=="qad.Storage") t = "storage";
                            else if (tc.get("type") == "qad.Addressnotevent" || tc.get("type") == "qad.Address") t = "object";
                            if (t) { 
                                var pn = p.src.port[0].getAttribute("option-id");
                                if (pn < f.outputs.length) { 
                                    if (!_.isArray(f.outputs[pn].v)) f.outputs[pn].v = [];
                                    var isExist = _.find(f.outputs[pn].v, function(val){
                                        return val.type == t && val.value == v;
                                    })
                                    if (!isExist) { 
                                        f.outputs[pn].v.push({
                                            type : t,
                                            value : v
                                        })
                                    }
                                }
                            }
                        }
                    })
                    
                    //ищем ссылки - триггеры
                    var p;
                    

                    var le = getTriggersForFunction(cell); 
                    /*_.filter(appView.graph.getLinks(), function(l){
                        var p = getTargetSource(l);
                        if (p.trg && p.trg.cell && p.trg.cell==cell && p.trg.port) { 
                            var port = p.trg.port[0];
                            return port.getAttribute("type") == "input";
                        }
                        return false;
                    })*/

                    if (le.length>0) { //ссылки найдены 
                        //f.triggers = []; 

                        _.each(le, function(l){
                            //тут должны быть только таймеры
                            var p = getTargetSource(l);
                            //ссылка - найдена 
                            if (l && p.src && p.src.cell) { 
                                var port = p.src.port;
                                p = p.src.cell;
                                var t = p.get("type");
                                if (e=="timer" && t=="qad.Timer") { 
                                    var v = parseInt(p.get("value"));
                                    if (_.isNaN(v)) return true;
                                    f.triggers.push({t:"timer", v:v});
                                }else { 
                                  /*  e = parseInt(e); 
                                    if (!_.isNaN(e) && e<f.inputs.length) { 
                                        var inputsModel = m.get("input");

                                        if (t=="qad.Address" || t=="qad.Tag") { 
                                            var v = p.get("value");
                                            if (_.isString(v) && v.length>0) { 
                                                var trigg = { 
                                                    t : "event", 
                                                    n : e+1, 
                                                    ot : t=="qad.Address"  ? "address" : "tag",
                                                    v : v
                                                }

                                                if (e==-1) {
                                                    if (trigg.ot=="address" || trigg.ot=="tag") trigg.find = true;
                                                }else if (trigg.ot=="address" && inputsModel[e].fa) trigg.find = true;
                                                else if (trigg.ot=="tag" && inputsModel[e].ft) trigg.find = true;

                                                f.triggers.push(trigg);
                                            }
                                        }else if (t=="qad.Question") { 
                                            var id = parseInt(port.attr("option-id"));
                                            if (!_.isNaN(id)) { 
                                                var mvo = p.get("m").get("output");
                                                if (id<mvo.length) { 
                                                    mvo = mvo[id].values;
                                                    if (_.isArray(mvo)) { 
                                                        var v = _.find(mvo, function(m){ return m.type=="object" && _.isString(m.value) && m.value.length>0});
                                                        if (v) {
                                                            var trigg = { 
                                                                t : "event", 
                                                                n : e+1, 
                                                                ot : "address",
                                                                v : v.value
                                                            }

                                                            if (e==-1) {
                                                                if (trigg.ot=="address" || trigg.ot=="tag") trigg.find = true;
                                                            }else if (trigg.ot=="address" && inputsModel[e].fa) trigg.find = true;
                                                            else if (trigg.ot=="tag" && inputsModel[e].ft) trigg.find = true;

                                                            f.triggers.push(trigg)
                                                        }
                                                    }
                                                }
                                            }

                                        }
                                    }
                                    */
                                }
                            }
                        })
                    }


                    if (f.triggers.length==0) return true;
                    else (res.push(f));
                }
            })

            
            if (cell) {
                appView.selection.reset([cell]);
                new app.ModalError({error:"No event to run the selected block Function", reveal : {closeOnClick:true, closeOnEsc:true,}});
            }else if (res.length==0){
                new app.ModalError({error:"At least one block Function must be added", reveal : {closeOnClick:true, closeOnEsc:true,}});
            }else{ 
                var index = 0;
                //проходим все ссылки, которые не event (между функциями)
                _.each(appView.graph.getLinks(), function(l){
                    var s = getTargetSource(l);

                    if (s.trg && s.trg.cell && s.trg.port && s.src && s.src.cell && s.src.port && s.trg.cell.get("type")=="qad.Question" && s.src.cell.get("type")=="qad.Question" ) { 
                        if (l.attr(".connection").stroke!="orange") { //не event 
                            var outPort = s.src.port[0], inPort = s.trg.port[0];
                            if (inPort.getAttribute("type")=="in") { //если это в обычный вход функции 
                                var srcPortId = outPort.getAttribute("option-id");
                                var func = _.find(res, function(f) {
                                    return f.id == s.src.cell.get("id");
                                })

                                if (func && func.outputs.length>srcPortId) { 
                                    var typeV = "buffer", addr;
                                    //если среди исходщих параметров есть адрес - то он буфер 
                                    //если нет, то создадим буфер 
                                    if (_.isArray(func.outputs[srcPortId].v)){
                                        var a = _.find(func.outputs[srcPortId].v, function(v){
                                            return v.type=="object" && v.value;
                                        })
                                        if (a) addr = a.value;
                                    }

                                    var inputValue;

                                    if (_.isUndefined(addr)) {
                                        //создаем буфферный storage 
                                        if (_.isUndefined(func.outputs[srcPortId].buffer))
                                            func.outputs[srcPortId].buffer = ++index; 

                                        inputValue = {
                                            type : "buffer",
                                            value : func.outputs[srcPortId].buffer,
                                            name : func.outputs[srcPortId].n,
                                            nameFunc : func.name
                                        };
                                    
                                    }else{
                                        //значение берем из группового адреса 
                                        inputValue = {
                                            type: "object",
                                            value : addr
                                        }
                                    }

                                    var trgPortId = inPort.getAttribute("option-id");
                                    func = _.find(res, function(f) {
                                        return f.id == s.trg.cell.get("id");
                                    })

                                    if (func && func.inputs.length>trgPortId) 
                                        func.inputs[trgPortId].v = inputValue;

                                }
                            }
                        }
                    }//else l.remove();
                })

                var action = preview ? "preview" : "generate";
                $.post(
                    "api/?a=" + action, 
                    {gen:1, funcs : JSON.stringify(res), json:JSON.stringify(getAllJson()), id:appModel.get("diagramId")},
                    function (data, textStatus) {
                        if (textStatus=='success') new app.ModalCode({data:data, preview:preview})
                    }
                )
            }
        }

       appView.selection.error = false;
    }

})