$(function() {
	$("select").select2();

  parseJSON = function(data) { 
	  var d =false;
	  try { d = JSON.parse(data); } catch (e) {};   
	  return d;
	}

  if (isLive) window.mapping = {o:{}, s:{}};

  $(".main").css("height", $(window).height()-60);

  var appView = window.appView = new app.AppView();
	var appModel = window.appModel = new app.AppModel();
  var leftView, rightView;
  
  if (!isLive) {
    leftView = window.leftView = new app.LeftView({model:window.appModel});
    rightView = window.rightView = new app.ModalFuncView();
  }

  var topView = window.topView = new app.TopView();

    function prepareDataForSelect2Objects(){ 
        _.each(objects, function(o, id){
            var tags = o.tags;
            if (_.isUndefined(tags)) tags = ""; 
            tags = tags.split(",");
            objects[id].tags = _.chain(tags)
                .map(function(t){ return t.trim(); })
                .filter(function(t){ return t.length>0; })
                .value();
        });

        select2Data.objects = _.map(objects, function(o){
            o.text = o.address + (o.name ? " (" + o.name + ")" : "")
            return o; 
        });

        select2Data.tags = _.map(tags, function(o) { 
        	return { 
        		id : o, 
        		text : o
        	}
        })
        select2Data.objects = _.sortBy(select2Data.objects, function(o){return o.key})  	
        select2Data.tags = _.sortBy(select2Data.tags, function(o){return o.id})  	
    }

  
  select2Data = {}

  if (!isLive) prepareDataForSelect2Objects();
  if (isLive) {
    localbus.init();

    _.each(mapping.o, function(o, key){
        localbus.listen('object', key, function(value){
          if (_.isObject(value)){
            if ("year" in value) {
              value = value["year"] + "-" + addZero(value["month"]) + "-" + addZero(value["day"]);
            }else if ("hour" in value) {
              value = addZero(value["hour"]) + ":" + addZero(value["minute"]) + ":" + addZero(value["second"]);
            }else 
              value = "";
          }
          writeAddress(key, value);
        });
    })

    _.each(mapping.s, function(o, key){
        localbus.listen('storage', key, function(value){
          writeStorage(key, value);
        });
    })

    //удаляем блок с инструментами 
    _.each(appView.graph.getLinks(), function(l){
      var v = l.findView(appView.paper);
      v.$('.link-tools').remove();
    })

  }

});
