var app = app || {};


app.LeftView = Backbone.View.extend({
    el: '#left',
    templates: {
        main: _.template('\
			<div class="form form-horizontal search">\
				<div class="form-group"><div class="col-sm-12"><div class="input-group">\
					<input class="input-group-field" type="text" placeholder="leftmenu.search">\
					<div class="input-group-button"><a class="button secondary"><i class="fa fa-times" aria-hidden="true"></i></a></div>\
				</div></div></div>\
			</form>\
			<ul class="vertical menu left-menu" data-accordion-menu>\
                <li data-diagrams><a href="#" translate="leftmenu.diagrams.title">Diagrams</a>\
                    <ul class="menu vertical nested is-active">\
                        <%_.each(get("diagrams"), function(d){%>\
                            <li data-diagram="<%=d.id%>"><a href="javascript:;" class="js-diagram"><%=htmlspecialchars(d.name)%></a><i class="remove_diagram fa fa-times" aria-hidden="true"></i></li>\
                        <% }) %>\
                        <li><a href="#" data-add-diagram><i class="fa fa-plus" aria-hidden="true"></i> <span translate="leftmenu.diagrams.add">Add new</span></a></li>\
                    </ul>\
                </li>\
                <li data-elements data-search><a href="#" translate="leftmenu.event_elements">Add Event Elements</a>\
                    <ul class="menu vertical nested is-active">\
                        <li><a href="javascript:;"  data-add="timer"><i class="fa fa-clock-o" aria-hidden="true"></i>  <span translate="leftmenu.event_elements.Timer">Timer</span></a></li>\
                        <li><a href="javascript:;"  data-add="address"><i class="fa fa-cube" aria-hidden="true"></i> <span translate="leftmenu.event_elements.Address">Address</span></a></li>\
                        <li><a href="javascript:;"  data-add="tag"><i class="fa fa-tags" aria-hidden="true"></i> <span translate="leftmenu.event_elements.Tag">Tag</span></a></li>\
                    </ul>\
                </li>\
                <li data-elements-not-event data-search><a href="#" translate="leftmenu.elements">Add Elements</a>\
                    <ul class="menu vertical nested">\
                        <li><a href="javascript:;"  data-add="addressnotevent"><i class="fa fa-cube" aria-hidden="true"></i> <span translate="leftmenu.event.Address">Address</span></a></li>\
                        <li><a href="javascript:;"  data-add="storage"><i class="fa fa-database" aria-hidden="true"></i> <span translate="leftmenu.event.Storage">Storage</span></a></li>\
                        <li><a href="javascript:;" data-add="value"><i class="fa fa-pencil-square-o" aria-hidden="true"></i> <span translate="leftmenu.elements.Value" >Value</span></a></li>\
                        <li><a href="javascript:;" data-add="comment"><i class="fa fa-comment-o" aria-hidden="true"></i> <span translate="leftmenu.elements.Comment">Comment</span></a></li>\
                    </ul>\
                </li>\
                <li data-allfunctions><a href="#"><%=tr("rightform.all_functions") %></a><a href="print.lp" target="_blank"><i class="fa fa-print"></i></a></li>\
                <%_.each(get("functions"), function(f, i){ %>\
    				<li data-functions data-i="<%=i%>" <%if (!f.isUser) {%>data-custom<%}%>><a href="#"><%=htmlspecialchars(tr("functionanames."+f.name))%></a>\
    					<ul class="menu vertical nested">\
    						<%_.each(f.funcs, function(f, k){%>\
    	  						<li><a href="javascript:;" data-id="<%=k%>" class="right"><%=htmlspecialchars(tr(f.title))%></a><i class="fa fa-question-circle-o"></i></li>\
    						<%})%>\
    					</ul>\
    				</li>\
                <%})%>\
			</ul>\
	    	'),

        /* tooltipFunction: _.template('\
			<div class="tooltip">\
				<strong><%=(htmlspecialchars(tr(name)||""))%>:<%=(htmlspecialchars(tr(title)))%></strong><br/><%=(htmlspecialchars(tr(comment)))%><br/>\
				<strong><span translate="leftmenu.input">[Input]</span>></strong><br/><%_.each(input, function(p) { %><%=(htmlspecialchars(tr(p.n)))%> <% }) %>\
				<strong><br/><span translate="leftmenu.output">[Output]</span></strong><br/><%_.each(output, function(p) { %><%=(htmlspecialchars(tr(p.n)))%> <% }) %>\
			</div>\
		'), */

        formDiagram: _.template('<li data-diagram><input type="text"></li>'),
    },

    changeMenu: function () {
        var l = $("li[data-functions][aria-expanded=true]", this.el).length,
            c = $("li[data-allfunctions]", this.el);
        if (l > 0) c.addClass('open'); else c.removeClass('open');
    },

    render: function () {
        var model = this.model,
            view = this;
        $(this.el).html(this.templates.main(this.model));
        $(document).foundation();

        $("[data-accordion-menu]", this.$el).on("down.zf.accordionMenu", this.changeMenu);
        $("[data-accordion-menu]", this.$el).on("up.zf.accordionMenu", this.changeMenu);

        /* $("[data-functions]", this.el).each(function(){
            var i = $(this).data("i");
            $("a[data-id]", $(this)).each(function() {
                var f = model.func(i, $(this).data("id"));
                if (f) {
                    var elem = new Foundation.Tooltip($(this), {
                        "template": view.templates.tooltipFunction(f)
                    });
                }
            })
        }) */

        return this;
    },

    setDiagram: function () {
        var id = this.model.get("diagramId");
        $("[data-diagrams] li.active", this.$el).removeClass('active');
        $("[data-diagrams] li[data-diagram=" + id + "]", this.$el).addClass('active');
    },

    initialize: function () {
        this.render();
        this.listenTo(this.model, "change:diagramId", this.setDiagram);
        this.setDiagram();
    },

    events: {
        "click [data-allfunctions] a:first-of-type": function (e) {
            var c = $(e.currentTarget).closest('[data-allfunctions]'),
                m = $("[data-accordion-menu]", this.el);
            var action = c.hasClass('open') ? "up" : "down";
            $("[data-functions] ul", this.el).each(function () {
                m.foundation(action, $(this));
            })
        },

        "click [data-diagram] a.js-diagram": function (e) {
            var li = $(e.currentTarget).closest('li'),
                id = li.data("diagram");
            this.model.set("diagramId", id);
        },

        //управление списком диаграмм 
        "click a[data-add-diagram]": function (e) {
            if (confirmLeave()) {
                var li = $(e.currentTarget).closest('li');
                var f = $(this.templates.formDiagram());
                f.insertBefore(li);
                var s = $("ul.is-active", this.$el);

                Foundation.reInit($('[data-accordion-menu]', this.$el));

                $("input", f).focus();
            }
        },
        "focusout [data-diagram] input": function (e) {
            var i = $(e.currentTarget),
                li = i.closest('li'),
                id = li.data("diagram");
            t = this;
            i.prop("disabled", true);
            var name = i.val().trim();

            if ((!_.isString(id) || id.length == 0) && name.length == 0) name = tr("leftmenu.diagrams.new");

            if (name.length > 0) {
                var p = { name: name };
                if (_.isString(id) && id.length > 0) p.id = id;
                var t = this;
                $.post("api/?a=save_diagram", p, function (result) {
                    result = parseJSON(result);
                    if (_.isObject(result) && result.id) {
                        li.html('<a href="javascript:;" class="js-diagram">' + htmlspecialchars(result.name) + '</a><i class="remove_diagram fa fa-times" aria-hidden="true"></i>');
                        li.attr("data-diagram", result.id);
                        li.data("diagram", result.id);
                        t.model.set("diagramId", result.id);
                    }
                })
            } else
                li.remove();
        },
        "dblclick [data-diagram] a.js-diagram": function (e) {
            var li = $(e.currentTarget).closest('li'),
                name = $("a", li).text();

            li.html('<input type="text">');
            $("input", li).val(name).focus();
        },

        "click [data-diagram] i.remove_diagram": function (e) {
            var i = $(e.currentTarget),
                li = i.closest('li'),
                id = li.data("diagram");
            t = this;
            if (confirm(tr("leftmenu.diagrams.remove"))) {
                $.post("api/?a=remove_diagram", { id: id }, function (result) {
                    result = parseJSON(result);
                    if (_.isObject(result) && result.id) {
                        li.remove();
                        if (result.id == appModel.get("diagramId")) {
                            var id = false;
                            var l = $("[data-diagrams] li[data-diagram]", t.$el);
                            if (l.length > 0) id = l.eq(0).data("diagram");
                            appModel.set("diagramId", id);
                        }
                    }
                })
            }
        },

        "keypress [data-diagram] input[type=text]": function (e) {
            if (e.which == 13) {
                $(e.currentTarget).prop("disabled", true);
                if (/Chrome/.test(navigator.userAgent)) {

                } else {
                    $(e.currentTarget).focusout();
                }
            }
        },

        "click [data-elements] [data-add]": function (e) {
            var t = $(e.currentTarget).data("add");
    		/*if (t=="comment") 
    			appView.addAnswer(e);
    		else */if (t == "address")
                appView.addAddress(e);
            else if (t == "timer")
                appView.addTimer(e);
            else if (t == "tag")
                appView.addTag(e);
        },

        "click [data-elements-not-event] [data-add]": function (e) {
            var t = $(e.currentTarget).data("add");
            if (t == "comment")
                appView.addAnswer(e);
            else if (t == "storage")
                appView.addStorage(e);
            else if (t == "value")
                appView.addValue(e);
            else if (t == "addressnotevent")
                appView.addAddressNotEvent(e);
        },

        "click [data-functions] a[data-id]": function (e) {
            var t = $(e.currentTarget);
            var i = t.closest("[data-functions]").data("i");
            var f = this.model.func(i, t.data("id"));
            if (f) {
                var c = new app.FuncModel();
                c.set(_.clone(f));
                _.each(c.get("input"), function (i) {
                    i.value = {
                        type: defaultInputTypeValue(i),
                        value: false
                    }
                });
                _.each(c.get("output"), function (o) {
                    o.show = false;
                    o.values = []
                });
                c.set("timer", 30);
                c.set("event", "timer");
                //c.set("tttemplate",  this.templates.tooltipFunction(f));

                window.uiUserAddedClick = true;
                c.updateShape();
            }
        },

        "click div.search a.button": function (e) {
            e.preventDefault();
            $("div.search input", this.el).val("").trigger("change");
            return false;
        },

        "submit div.search": function (e) {
            e.preventDefault();
            return false;
        },

        "change div.search input": "eFilter",
        "keyup div.search input": "eFilter",

        "mouseover [data-functions] a[data-id]": "showHelpPanel",
        "mouseout [data-functions] a[data-id]": "hideHelpPanel",

        "mouseover [data-functions] .menu li .fa": "showHelpPanel",
        "mouseout [data-functions] .menu li .fa": "hideHelpPanel",
        "click [data-functions] .menu li .fa": "showHelpPanel"
    },
    filter: "",
    eFilter: function (e) {
        var v = $("div.search input", this.el).eq(0).val().trim().toUpperCase();
        if (this.filter !== v) {
            this.filter = v;

            var t = this;

            _.each(this.model.get("functions"), function (cat, j) {
                var isFunсs = false;
                var catEl = $("[data-i=" + j + "]", t.$el);

                _.each(cat.funcs, function (f, i) {
                    var l = $("a[data-id=" + i + "]", catEl).eq(0).closest('li');

                    if (v.length = 0) { l.show(); isFunсs = true; }
                    else {
                        var title = f.title.toUpperCase(),
                            category = f.category.toUpperCase(),
                            comment = f.comment.toUpperCase(),
                            name = f.name.toUpperCase();

                        if (title.indexOf(v) >= 0 || category.indexOf(v) >= 0 || name.indexOf(v) >= 0 || comment.indexOf(v) >= 0) {
                            l.show();
                            isFunсs = true;
                        } else {
                            l.hide();
                        }
                    }
                })

                if (isFunсs) catEl.show(); else catEl.hide();
            })


            var dd = $("[data-search]", this.$el);
            isFunсs = false;
            _.each($("li", dd), function (l) {
                if (v.length = 0) { $(l).show(); isFunсs = true; }
                else {
                    var text = $("a", l).text().toUpperCase();
                    if (text.indexOf(v) >= 0) {
                        $(l).show();
                        isFunсs = true;
                    } else
                        $(l).hide();
                }
            })
            if (isFunсs) dd.show(); else dd.hide();
        }
    },

    showHelpPanel: function (e) {
        var target = $(e.currentTarget);
        var func_i = target.closest("[data-functions]").data("i");
        var func_key = target.data("id");
        if (func_key == null)
            func_key = target.prev("a[data-id]").data("id");
        var func = this.model.func(func_i, func_key);
        if (e.type == "click") {
            var position = {
                my: "left-top",
                at: "left-top",
                of: "#app",
                offsetX: 0,
                offsetY: 0
            };
            app.showHelpPanel(func, position, true);
        }
        else {
            app.highlightHelpPanel(func);
        }
    },
    hideHelpPanel: function (e) {
        var target = $(e.currentTarget);
        var func_i = target.closest("[data-functions]").data("i");
        var func_key = target.data("id");
        if (func_key == null)
            func_key = target.prev("a[data-id]").data("id");
        var func = this.model.func(func_i, func_key);
        app.hideHelpPanel(func);
    }
})