var аapp = app || {};

app.AppModel = Backbone.Model.extend({
	defaults : { 
		functions : {},
		diagrams : {},
		diagramId : false,
	},

	setDiagram : function() { 
		appView.graph.clear();
		var s = this.get("diagramId");
		if (_.isString(s)) {
			localStorage.setItem("diagramId", this.get("diagramId"));
			$.getJSON("api/?a=get_diargam", {id:this.get("diagramId")}, function(json){
				if (json!=0) diagramFromJson(json);
			})
		}
	},

	initialize : function() {
		var t=this;
		var funcs = {}; 
		for (var id in functions) { 
			funcs[id]=functions[id];
		}
		t.set("functions", funcs);

		if (!isLive) t.set("diagrams", diagrams);

		this.trigger("init"); 

		//устанавливаем текущую диаграмму 
		if (!isLive) {
			this.listenTo(this, "change:diagramId", this.setDiagram);
			var diagramId = localStorage.getItem("diagramId");
			if (_.isString(diagramId)) { 
				var diagram = _.find(diagrams, function(d) { return d.id==diagramId });
				if (!diagram) diagramId = false;
			}
			if (!_.isString(diagramId)) diagramId = diagrams[0].id;
			if (_.isString(diagramId)) this.set("diagramId", diagramId);
		}else { 
			if (_.isObject(ajson)) diagramFromJson(ajson);
		}
	},

	func : function(i, key) { 
		var f = false; 
		if (i in this.attributes.functions) {
			if (key in this.attributes.functions[i].funcs) {
				f = this.attributes.functions[i].funcs[key];
			}
			if (f) f= JSON.parse(JSON.stringify(f));
			f.file = this.attributes.functions[i].file;
		}

		//console.log(f);
		return f;
	}
})


app.FuncModel = Backbone.Model.extend({
	defaults : {
		input : [], 
		output : [], 
		event : "timer",
		tttemplate : null
	},

	initialize : function(){ 
		//console.log(this.attributes);			
	},

	hideOutOption : function(id) { 
		var output = this.attributes.output || []; 
		if (id in output) { 
			output[id].show=false; 
			var shape = this.get("shape");
			if (shape) shape.set("outOptions", this.getOutputsForShape())
		}
	},

	updateShape : function() { 
		if (!this.get("shape")) {
		    var q = new joint.shapes.qad.Question({
		        size: { width: 100, height: 70 },
		        question: tr(this.get("title")),
		        outOptions: this.getOutputsForShape(),
		        inOptions: this.getInputsForShape(),
                tttemplate : this.get("tttemplate"),
		        //labelEvent : this.getLabelForEvent(),
		        m_attr : this.attributes,
		        m: this,
		    });
		    appView.graph.addCell(q);
		    appView.status(tr("models.function_added"));
            q.set("tttemplate",this.get("tttemplate"))
		    this.set("shape", q);
		    return q;
		} else {
		    this.get("shape").set({
		        outOptions: this.getOutputsForShape(),
		        inOptions: this.getInputsForShape(),
		       // labelEvent : this.getLabelForEvent(),
		        m_attr : this.attributes,
		    });
		    this.get("shape").trigger("updateShape");
		}
	},

    //исходящие параметры для фигуры-функции
	getOutputsForShape: function() {
	        var result = [];
	        _.each(this.get("output"), function(p, i) {
	            if (p.show) {
					if (!_.isArray(p.values)) p.values = []; 	            	
	            	var o = _.find(p.values, function(v) { return v.type=="object" && v.value });
	                result.push({
	                    id: i,
	                    text:tr( p.l || p.n),
	                    show: p.show,
	                    bus : _.isUndefined(p.bus) ? true : p.bus,
	                    values: p.values,
	                    enableEvent : !_.isUndefined(o), //может быть event портом  
	                    portLabel : _.isUndefined(o) ? false : o.value
	                });
	            }
	        })
	        return result;
	},

    //входящие параметры для фигуры-функции
    getInputsForShape: function() {
    	var e = this.get("event");
        var result = [];

        _.each(this.get("input"), function(p, i) {
        	if (p.show /*&& i!=e*/) { 
        		//console.log(p.value.type);
                result.push({
                    id: i,
                    text: tr(p.n) + " (" + p.value.type + (p.value.value ? ": " + p.value.value : "") + ")",
                    value: p.value,
                    label: tr(p.n)
                });
        	}

        })
        return result;
    },

})