$(function () {
  var $body = $("body");

  var getText = function (category, func, suffix) {
    return tr("functions." + category.name + ".json." + func.name + suffix);
  }

  // Table of contents
  $.each(functions, function (_, category) {
    $body.append("<div class='category'>" + tr(category.name) + "</div>");

    $.each(category.funcs, function (_, func) {
      $body.append("<a href='#" + func.name + "' class='function-link'>" + getText(category, func, ".title") + "</a>");
    });
  });

  // Functions
  $.each(functions, function (_, category) {
    $.each(category.funcs, function (_, func) {
      var $container = $("<div id='" + func.name + "' class='function'></div>");
      $body.append($container);

      // Title
      $container.append("<p><b>" + getText(category, func, ".title") + "</b></p>");

      // Category
      $container.append("<p><b>" + tr("help.category") + "</b> " + tr("functionanames." + category.name) + "</p>");

      // Description
      $container.append("<p><b>" + tr("help.description") + "</b></p>");
      $container.append("<p>" + getText(category, func, ".comment") + "</p>");

      // Table with inputs
      if (func.input.length > 0) {
        var $inputsTable = $("<table></table>");
        $container.append($inputsTable);

        var $inputsTable_Header = $("<tr></tr>");
        $inputsTable.append($inputsTable_Header);
        for (let i = 1; i <= 4; i++) {
          $inputsTable_Header.append("<th>" + tr("help.inputs.header." + i) + "</th>");
        }

        for (let i = 0; i < func.input.length; i++) {
          const input = func.input[i];
          var suffix = ".input." + (i + 1);
          var $inputRow = $("<tr></tr>");
          $inputsTable.append($inputRow);
          $inputRow.append("<td>" + getText(category, func, suffix) + "</td>");
          $inputRow.append("<td>" + getText(category, func, suffix + ".init") + "</td>");
          $inputRow.append("<td>[" + input.t.join(", ") + "]</td>");
          $inputRow.append("<td>" + getText(category, func, suffix + ".description") + "</td>");
        }
      }

      // Table with outputs
      if (func.output.length > 0) {
        var $outputsTable = $("<table></table>");
        $container.append($outputsTable);

        var $outputsTable_Header = $("<tr></tr>");
        $outputsTable.append($outputsTable_Header);
        for (let i = 1; i <= 4; i++) {
          $outputsTable_Header.append("<th>" + tr("help.outputs.header." + i) + "</th>");
        }

        for (let i = 0; i < func.output.length; i++) {
          const output = func.output[i];
          var suffix = ".output." + output.n;
          var $outputRow = $("<tr></tr>");
          $outputsTable.append($outputRow);
          $outputRow.append("<td>" + getText(category, func, suffix) + "</td>");
          $outputRow.append("<td>" + getText(category, func, suffix + ".init") + "</td>");
          $outputRow.append("<td>[" + output.t.join(", ") + "]</td>");
          $outputRow.append("<td>" + getText(category, func, suffix + ".description") + "</td>");
        }
      }
    });
  });
});