var app = app || {};

app.Selection = Backbone.Collection.extend();

app.SelectionView = Backbone.View.extend({
    initialize: function(options) {
        this.options = options;
        _.bindAll(this, 'render');
        this.listenTo(this.model, 'add reset change', this.render);
        this.listenTo(this.model, 'remove', this.remove);
    },


    error : false, 

    render: function(isError) {
        var t = this;
        var paper = this.options.paper;
        var boxTemplate = V('rect', { fill: 'none', 'stroke': t.model.error ? "red" : '#C6C7E2', 'stroke-width': 1, 'pointer-events': 'none' });

        _.invoke(this.boxes, 'remove');
        this.boxes = [];
        this.model.each(function(element) {
            var box = boxTemplate.clone();
            var p = 3; // Box padding.
            box.attr(g.rect(_.extend({}, element.get('position'), element.get('size'))).moveAndExpand({
                x: -p, y: -p, width: 2*p, height: 2*p 
            }));
            V(paper.viewport).append(box);
            this.boxes.push(box);
        }, this);

        var needClear = true;
        if (this.model.length==1) { 
            var m = this.model.models[0];
            var t = m.get("type"); 
            if (t=="qad.AddAddress" || t=="qad.Address" || t=="qad.Tag"  || t=="qad.Timer" || t=="qad.Question" || t=="qad.Storage" || t=="qad.Value" || t=="qad.Addressnotevent") {
                rightView.initModel(m);
                needClear = false; 
            }
        }

        if (needClear) rightView.clearAll();

        /*
        if (this.model.get("type")=="qad.Address") {
            console.log("21334142");
        }else if (this.model.length==1 && this.model.models[0].get("m")) { 
            rightView.initModel(this.model.models[0].get("m"));
        }else{ 
            
        }
        */
        
        return this;
    }
});
