
function getAllJson() { 
    var json = appView.graph.toJSON();

    json.cells = _.map(json.cells, function(c) {
        if (c.type=="qad.Question") {
            if ("m" in c) {
                c.m_attr = c.m.attributes;
                if ("shape" in c.m_attr) delete c.m_attr.shape;
                delete c.m;
            }
        }
        return c 
    })

    return json;
}


app.TopView = Backbone.View.extend({
    el: "#top",
    initialize: function() {},
    events: {
        "click .js-zoom-plus": function() {
            appView.paperScroller.zoom(0.2, { max: 5, grid: 0.2 });
            //appView.afterZoom(); 
        },
        "click .js-zoom-minus": function() {
            appView.paperScroller.zoom(-0.2, { min: 0.2, grid: 0.2 });
        },
        "click .js-print": function() {
            appView.paper.print();
        },
        "click .js-undo": function() {
            appView.commandManager.undo();
        },
        "click .js-redo": function() {
            appView.commandManager.redo();
        },
        "click .js-clear" : function() { 
            if (confirm("All items will be deleted. Continue?"))
                appView.graph.clear()  
        },
        "click .js-live" : function() { 
            var id = appModel.get("diagramId");
            if (id) { 
                var link = document.createElement('a');
                link.href = "live.lp?id="+id;
                link.target =  "_blank";
                document.body.appendChild(link);
                link.click();
                document.body.removeChild(link);                
            }
        },
        "click .js-save" : function() { 
            var link = document.createElement('a');
            var blob = new Blob([JSON.stringify(getAllJson())], { type: 'application/json' });
            link.href = URL.createObjectURL(blob);
            link.download = 'fbeditor.json';
            document.body.appendChild(link);
            link.click();
            document.body.removeChild(link);
        },

        "click .js-preview" : function() { 
            generateCode(true);
        },

        "click .js-generate" : function() { 
            generateCode();
        },

        "click .js-load" : function() { 
            $("#json-file").click();
        },
        "change #json-file": function(e) {
            var f = e.target.files[0];
            if (f) {
                var r = new FileReader();
                r.onload = function(e) {
                    var s = false;
                    if (f.name.match(/\.json$/i)) {
                        var json = e.target.result;
                        var r;
                        try { r = JSON.parse(json); } catch (exc) {}
                        if (r) { 
                            appView.graph.fromJSON(r);
                            _.each(appView.graph.getElements(), function(m) {
                                if ("m_attr" in m.attributes) { 
                                    m.attributes.m_attr.shape = m;
                                    m.attributes.m=new app.FuncModel(m.attributes.m_attr); 
                                    m.attributes.m.updateShape();
                                    delete m.attributes.m_attr;
                                    if (m.init) m.init();
                                }
                            });

                            _.each(appView.graph.getLinks(), function(l) { 
                                changeTarget(l);
                            });
                            s = true;
                        }
                    }
                    if (!s) alert("Failed to load file");
                }
                r.readAsText(f);
            } else {
                alert("Failed to load file");
            }
            $(this).val("");
        }

    }
})